unit uPrint;

{$MODE Delphi}
{$IFDEF APLICACION_CONSOLA}
{$DEFINE SIMRES3SOLOTEXTO}
{$ENDIF}
{$IFDEF LINUX}
{$DEFINE SIM_EXCEL}
{$ENDIF}
{$IFDEF FORM_LIBRO_SIMSEE}
{$DEFINE SIM_EXCEL}
{$ENDIF}
interface

uses
{$IFNDEF SIMRES3SOLOTEXTO}
{$IFDEF WINDOWS}
  Windows,
  XLConst,
  ComObj,
{$ENDIF}
  uExcelFile,
  Graphics,
{$ENDIF}
  Math, xMatDefs,
  SysUtils, uAuxiliares, uFechas;

type
  TTipoGrafico = (areaApilada, dispersion, linea);   // OJO NO CAMBIAR EL ORDEN
  TDAOfTTipoGrafico = array of TTipoGrafico;
  TTipoEje = (Primario, Secundario);
  TDAOfTTipoEje = array of TTipoEje;
  TTipoValoresAComparar = (Promedios, DesviacionesEstandar,
    ProbabilidadesDeExcedencia, ValoresEnRiesgo);
{$IFNDEF SIMRES3SOLOTEXTO}
  TDAOfTColor = array of TColor;

const
  colorAutomatico = clDefault;
//TODO ver la forma de que dllexcel use colorAutomatico y no clDefault
{$ENDIF}

function nroColToExcelStrCol(nroCol: integer): string;

procedure WriteMatToText(nombreArch: string; mat: TMatOfNReal;
  titulo: string; nPasos: integer; nCronicas: integer; dtFechaPrimerPaso: TDateTime;
  dtPaso: double; digitos, decimales: integer; Print_Todas: boolean;
  Print_promedio: boolean; Pre_Ordenar: boolean; TipoImpresion_PE: boolean;
  Print_probAisladas: TDAofNReal);

{$IFNDEF SIMRES3SOLOTEXTO}
procedure chartMat_SimpleEje_ColoresAuto(xls: TExcelFile; nombreHoja: string;
  titulo, ejeY: string; colIni, colFin, filaIni, filaFin: integer;
  minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal;
  minEjeX, MaxEjeX: NReal; tipoGrafico: TTipoGrafico; dtPaso: TDateTime);

procedure chartMat_MultiEje_Coloreable(xls: TExcelFile; nombreHoja: string;
  titulo, ejeY: string; colIni, colFin, filaIni, filaFin: integer;
  minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal;
  minEjeX, MaxEjeX: NReal; tiposDeGrafico: TDAOfTTipoGrafico;
  ejes: TDAOfTTipoEje; colores: TDAOfTColor; dtPaso: TDateTime);
  overload;



(* ??? por ahora lo comento
procedure aplicarPropiedadesASeries(xls: TExcelFile; nombreHoja: String;
                                    tipoGraficoPrincipal: TTipoGrafico; tiposGraficos: TDAOfTTipoGrafico;
                                    ejes: TDAOfTTipoEje;
                                    colores: TDAOfTColor);
*)


procedure WriteMatToXLS(xls: TExcelFile; nombreHoja: string;
  mat: TMatOfNReal; titulo, unidades: string; nPasos: integer;
  nCronicas: integer; dtFechaPrimerPaso: TDateTime; dtPaso: double;
  decimales: integer; Print_Todas: boolean; Print_promedio: boolean;
  Pre_Ordenar: boolean; TipoImpresion_PE: boolean; Print_probAisladas: TDAofNReal;
  chart_Mat: boolean; minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal);

procedure writeHistogramaGlobalToXls(xls: TExcelFile; nombreHoja: string;
  mat: TMatOfNReal; titulo, unidades: string; decimales: integer;
  minX, maxX: NReal; nPuntos: integer{;
                                     chart_Mat: boolean;
                                     minEjeYAuto, maxEjeYAuto: boolean;
                                     minEjeY, MaxEjeY: NReal});



procedure WriteMatToXLS_SinOrdenar(xls: TExcelFile; nombreHoja: string;
  mat: TMatOfNReal; titulo, unidades: string; titulosCols: TDAofString;
  nPasos: integer; nCronicas: integer; dtFechaPrimerPaso: TDateTime;
  dtPaso: double; decimales: integer; Print_promedio: boolean;
  chart_Mat: boolean; minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal);


procedure WriteValoresToXLS(xls: TExcelFile; tipoValores: TTipoValoresAComparar;
  probExcedencia: NReal; Pre_Ordenar: boolean; ProbExcedencia_Sup: NReal;
  nombresVars: TDAofString; mats: array of TMatOfNReal; nombreHoja: string;
  titulo, unidades: string; dtFechaPrimerPaso: TDateTime; dtPaso: double;
  decimales: integer; graficar: boolean; tiposGraficos: TDAOfTTipoGrafico;
  ejes: TDAOfTTipoEje; colores: TDAOfTColor; minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);

function TTipoGraficoToXLConst(tipoGrafico: TTipoGrafico;
  TipoPrincipal: TTipoGrafico = dispersion): integer;

function TTipoGraficoToString(tipoGrafico: TTipoGrafico): string;
function StringToTTipoGrafico(tipoGrafico: string): TTipoGrafico;

function TTipoEjeToXLConst(tipoEje: TTipoEje): integer;
function TTipoEjeToString(tipoEje: TTipoEje): string;
function StringToTTipoEje(tipoEje: string): TTipoEje;

function TTipoValoresACompararToString(tipoValoresAComparar:
  TTipoValoresAComparar): string;
function StringToTTipoValoresAComparar(tipoValoresAComparar: string):
  TTipoValoresAComparar;
function TTipoValoresACompararToShortStringSingular_(tipoValoresAComparar:
  TTipoValoresAComparar; probExcedencia: NReal): string;

{$ENDIF}



resourcestring
  RS_DISPERSION = 'Dispersin';
  RS_AREAS_APILADAS = 'Areas Apiladas';
  RS_PROBABILIDAD_ACUMULADA = 'Probabilidad Acumulada';
  RS_XLS_PROMEDIO = 'Prom';
  RS_XLS_DESVIACION_ESTANDAR = 'DesvE';
  RS_XLS_PROBABILIDAD_DE_EXCEDENCIA = 'PE_';
  RS_XLS_VALOR_EN_RIESGO = 'VaR_';




implementation


function promediarProbs(const v: TDAofNReal; kCron1, kCron2: integer): NReal;
var
  a: NReal;
  k: integer;
begin
  a := 0;
  for k := kCron1 to kCron2 do
    a := a + v[k];
  Result := a / (kCron2 - kCron1 + 1);
end;


function nroColToExcelStrCol(nroCol: integer): string;
const
  ExcelCols = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var
  iLetra: integer;
  res: string;
begin
  res := '';

  while nroCol > Length(ExcelCols) do
  begin
    iLetra := nroCol div Length(ExcelCols);
    res := res + ExcelCols[iLetra];
    nroCol := nroCol - iLetra * Length(ExcelCols);
  end;
  res := res + ExcelCols[nroCol];

  Result := res;
end;

procedure WriteMatToText(nombreArch: string; mat: TMatOfNReal;
  titulo: string; nPasos: integer; nCronicas: integer; dtFechaPrimerPaso: TDateTime;
  dtPaso: double; digitos, decimales: integer; Print_Todas: boolean;
  Print_promedio: boolean; Pre_Ordenar: boolean; TipoImpresion_PE: boolean;
  Print_probAisladas: TDAofNReal);

var
  sal: textfile;
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  iProbAisladas: array of integer;
  aprom: NReal;
  kProb: integer;
  hayAdicionales: boolean;
  aval: NReal;
begin
  setlength(iProbAisladas, length(Print_probAisladas));
  for kProb := 0 to high(Print_probAisladas) do
  begin
    iCronica := round(NCronicas * Print_probAisladas[kProb]) - 1;
    if iCronica < 0 then
      iCronica := 0;
    iProbAisladas[kProb] := iCronica;
  end;

  hayAdicionales := Print_promedio or (length(Print_probAisladas) > 0);

  if pos('.', nombreArch) = 0 then
    assignfile(sal, nombreArch + '_rpex.xlt')
  else
    assignfile(sal, nombreArch);

  rewrite(sal);

  writeln(sal, titulo);
  Write(sal, 'paso');

  if Print_Todas then
  begin
    Write(sal, #9);
    for iCronica := 0 to NCronicas - 1 do
      Write(sal, #9, ((iCronica + 1) / NCronicas * 100): 6: 1, '%');
  end;

  if hayAdicionales then
  begin
    Write(sal, #9, #9);
    if Print_Promedio then
      Write(sal, #9, 'Prom');
    if TipoImpresion_PE then
    begin
      for kProb := 0 to high(iProbAisladas) do
        Write(sal, #9, 'Pe' + FloatToStrF(Print_ProbAisladas[kProb] *
          100, ffFixed, 6, 1) + '%');
    end
    else
    begin
      for kProb := 0 to high(iProbAisladas) do
        Write(sal, #9, 'VaR' + FloatToStrF(Print_ProbAisladas[kProb] *
          100, ffFixed, 6, 1) + '%');
      Write(sal, #9, 'VaR' + FloatToStrF(100, ffFixed, 6, 1) + '%');
    end;
  end;

  writeln(sal);
  for iPaso := 0 to NPasos - 1 do
  begin
    if Pre_Ordenar then
      QuickSort_Decreciente(mat[iPaso]);
    fechaDelPaso := dtFechaPrimerPaso + dtPaso * iPaso;
    Write(sal, iPaso);

    if Print_Todas then
      Write(sal, #9, DateTimeToStr(fechaDelPaso));

    aProm := 0;
    for iCronica := 0 to NCronicas - 1 do
    begin
      aval := mat[iPaso][iCronica];
      if Print_Todas then
        Write(sal, #9, FloatToStrF(aval, ffFixed, digitos, decimales));
      aProm := aProm + aval;
    end;
    aProm := aProm / NCronicas;

    if hayAdicionales then
    begin
      Write(sal, #9, #9, DateTimeToStr(fechaDelPaso));
      if Print_Promedio then
        Write(sal, #9, FloatToStrF(aProm, ffFixed, digitos, decimales));

      if TipoImpresion_PE then
      begin
        for kProb := 0 to high(iProbAisladas) do
          Write(sal, #9, FloatToStrF(mat[iPaso][iProbAisladas[kProb]]
            , ffFixed, digitos, decimales));
      end
      else
      begin
        aval := promediarProbs(mat[iPaso], 0, iProbAisladas[0]);
        Write(sal, #9, FloatToStrF(aval, ffFixed, digitos, decimales));
        for kProb := 1 to high(iProbAisladas) do
        begin
          aval := promediarProbs(mat[iPaso], iProbAisladas[kProb - 1],
            iProbAisladas[kProb]);
          Write(sal, #9, FloatToStrF(aval, ffFixed, digitos, decimales));
        end;
        aval := promediarProbs(mat[iPaso], iProbAisladas[high(iProbAisladas)],
          NCronicas - 1);
        Write(sal, #9, FloatToStrF(aval, ffFixed, digitos, decimales));
      end;
    end;
    writeln(sal);
  end;
  writeln(sal);
  closefile(sal);
end;

{$IFNDEF SIMRES3SOLOTEXTO}

procedure chartMat_SimpleEje_ColoresAuto(xls: TExcelFile; nombreHoja: string;
  titulo, ejeY: string; colIni, colFin, filaIni, filaFin: integer;
  minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal;
  minEjeX, MaxEjeX: NReal; tipoGrafico: TTipoGrafico; dtPaso: TDateTime);
var
  nombreHojaGrafico: Shortstring;
  hojag: variant;
begin
  nombreHojaGrafico := xls.graficar(PurificarNombreHoja(nombreHoja),
    colIni, colFin, filaIni, filaFin);

  xls.aplicarPropiedadesAGrafico(nombreHojaGrafico,
    TTipoGraficoToXLConst(TipoGrafico),
    titulo, ejeY, minEjeYAuto, maxEjeYAuto,
    minEjeY, MaxEjeY, minEjeX, MaxEjeX);

  {$IFNDEF SIM_EXCEL}
  hojag := xls.v.Workbooks[1].Charts[nombreHojaGrafico];
  hojag.Select;
  hojag.Axes(xlCategory).Select;
  hojag.Axes(xlCategory).TickLabels.Orientation := xlHorizontal;
  if xls.version < 12.0 then // Office2007
    hojag.Axes(xlCategory).TickLabels.Orientation := 73
  else
    hojag.Axes(xlCategory).TickLabels.Orientation := -89;

  hojag.Axes(xlCategory).MajorTickMark := xlOutside;
  hojag.Axes(xlCategory).MinorTickMark := xlInside;
  hojag.Axes(xlCategory).TickLabelPosition := xlLow;


  //  hojag.Axes(xlCategory).MajorGridlines.Select;
  if dtPaso = 1.0 / 24.0 then
  begin
    if tipoGrafico = areaApilada then
    begin
      hojag.Axes(xlCategory).TickLabelSpacing := 24;
      hojag.Axes(xlCategory).TickMarkSpacing := 12;
    end
    else
    begin
      hojag.Axes(xlCategory).MajorUnit := 1;
      hojag.Axes(xlCategory).MinorUnit := 1 / 4;
    end;
  end
  else if dtPaso = 1 then
  begin
    hojag.Axes(xlCategory).HasMinorGridlines := False;
    if tipoGrafico = areaApilada then
    begin
      hojag.Axes(xlCategory).TickLabelSpacing := 7;
      hojag.Axes(xlCategory).TickMarkSpacing := 1;
    end
    else
    begin
      hojag.Axes(xlCategory).MajorUnit := 7;
      hojag.Axes(xlCategory).MinorUnit := 1;
    end;
  end
  else if dtPaso >= 7 then
  begin
    if tipoGrafico = areaApilada then
    begin
      hojag.Axes(xlCategory).TickLabelSpacing := 4;
      hojag.Axes(xlCategory).TickMarkSpacing := 1;
    end
    else
    begin
      hojag.Axes(xlCategory).MajorUnit := 365.2425 / 1.0;
      hojag.Axes(xlCategory).MinorUnit := 365.2425 / 3.0;
    end;
  end;


  hojag.Axes(xlCategory).HasMajorGridlines := True;
  hojag.Axes(xlCategory).HasMinorGridlines := True;

  hojag.Axes(xlCategory).MajorGridlines.Border.ColorIndex := 15;
  //    hojag.Axes(xlCategory).MajorGridlines.Border.Weight:= xlThick;
  hojag.Axes(xlCategory).MajorGridlines.Border.LineStyle := xlDashDot;


  hojag.Axes(xlCategory).MinorGridlines.Border.ColorIndex := 15;
  hojag.Axes(xlCategory).MinorGridlines.Border.Weight := xlHairline;
  hojag.Axes(xlCategory).MinorGridlines.Border.LineStyle := xlDot;

{$ENDIF}
end;

procedure chartMat_MultiEje_Coloreable(xls: TExcelFile; nombreHoja: string;
  titulo, ejeY: string; colIni, colFin, filaIni, filaFin: integer;
  minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal;
  minEjeX, MaxEjeX: NReal; tiposDeGrafico: TDAOfTTipoGrafico;
  ejes: TDAOfTTipoEje; colores: TDAOfTColor; dtPaso: TDateTime);
var
  nombreHojaGrafico: WideString;
  iterTipoGrafico, tipoGraficoPrincipal: TTipoGrafico;

  i, max_cnt_TiposGraficos: integer;
  cnt_TiposGraficos: array [TTipoGrafico] of integer;
  hojag: variant;
  tipoPrincipal: integer;
  eje_x, plot_area: variant;
  AltoPlotArea: double;

begin

  // limpiamo los contadores
  for iterTipoGrafico := low(cnt_TiposGraficos) to high(cnt_TiposGraficos) do
    cnt_TiposGraficos[iterTipoGrafico] := 0;

  // recorremos el vector de tipos para contar cuantos hay de cada tipo
  for i := 0 to high(tiposDeGrafico) do
    Inc(cnt_TiposGraficos[tiposDeGrafico[i]]);


  // determinamos el tipo cuyo contador de mximo y lo definimos como el TipoGraficoPrincipal
  max_cnt_TiposGraficos := 0;
  tipoGraficoPrincipal := dispersion;
  for iterTipoGrafico := low(cnt_TiposGraficos) to high(cnt_TiposGraficos) do
    if cnt_TiposGraficos[iterTipoGrafico] > max_cnt_TiposGraficos then
    begin
      max_cnt_TiposGraficos := cnt_TiposGraficos[iterTipoGrafico];
      tipoGraficoPrincipal := iterTipoGrafico;
    end;

  // xls.VisibleOn;

  TipoPrincipal := TTipoGraficoToXLConst(tipoGraficoPrincipal);

  if TipoGraficoPrincipal = areaApilada then
  begin
    if (dtPaso < 1) then
    begin
      xls.SelRango(filaIni + 1, colIni, filaFin, colIni);
      xls.CambiarFormato(xf_formatoStr(8));
    end;
  end;

  {$IFNDEF SIM_EXCEL}
  nombreHojaGrafico := xls.graficar(PurificarNombreHoja(nombreHoja),
    colIni, colFin, filaIni, filaFin, TipoPrincipal);
  {$ELSE}
  nombreHojaGrafico := xls.graficar(PurificarNombreHoja(nombreHoja),
    colIni, colFin, filaIni, filaFin);
  {$ENDIF}

  xls.aplicarPropiedadesAGrafico(nombreHojaGrafico,
    TipoPrincipal,
    titulo, ejeY, minEjeYAuto, maxEjeYAuto,
    minEjeY, MaxEjeY, minEjeX, MaxEjeX);

  for i := 0 to high(tiposDeGrafico) do
  begin
    xls.aplicarPropiedadesASerie(nombreHojaGrafico, i + 1,
      TTipoGraficoToXLConst(tipoGraficoPrincipal),
      TTipoGraficoToXLConst(tiposDeGrafico[i], TipoGraficoPrincipal),
      TTipoEjeToXLConst(ejes[i]), colores[i]);
  end;

  {$IFNDEF SIM_EXCEL}
  //  if TTipoGraficoToXLConst(tipoGraficoPrincipal) = xlAreaStacked then
  begin
    hojag := xls.v.Workbooks[1].Charts[nombreHojaGrafico];
    hojag.Select;
 (*
    hojag.ChartType := xlAreaStacked;
    for i := 0 to high(tiposDeGrafico) do
      hojag.SeriesCollection(i + 1).ChartType := TTipoGraficoToXLConst(tiposDeGrafico[i]);
   *)
    eje_x := hojag.Axes(xlCategory);
    eje_x.Select;




    eje_x.TickLabels.NumberFormat := WideString('0.00000000');
    if dtPaso >= 1 then
      eje_x.TickLabels.NumberFormat := WideString(ShortDateFormat)
    else
      eje_x.TickLabels.NumberFormat := WideString(ShortDateFormat + ' hh');

    hojag.Axes(xlCategory).Select;
    hojag.Axes(xlCategory).TickLabels.Orientation := xlHorizontal;
    if xls.version < 12.0 then  // Office2007
      hojag.Axes(xlCategory).TickLabels.Orientation := 73
    else
      hojag.Axes(xlCategory).TickLabels.Orientation := -89;

    hojag.Axes(xlCategory).MajorTickMark := xlOutside;
    hojag.Axes(xlCategory).MinorTickMark := xlInside;

    hojag.Axes(xlCategory).TickLabelPosition := xlLow;

    hojag.Axes(xlCategory).HasMajorGridlines := True;
    hojag.Axes(xlCategory).HasMinorGridlines := True;

    hojag.Axes(xlCategory).MajorGridlines.Border.ColorIndex := 15;
    //  hojag.Axes(xlCategory).MajorGridlines.Border.Weight:= xlThick;
    hojag.Axes(xlCategory).MajorGridlines.Border.LineStyle := xlDashDot;

    // hojag.Axes(xlCategory).MinorGridlines.Select;
    hojag.Axes(xlCategory).MinorGridlines.Border.ColorIndex := 15;
    hojag.Axes(xlCategory).MinorGridlines.Border.Weight := xlHairline;
    hojag.Axes(xlCategory).MinorGridlines.Border.LineStyle := xlDot;


    //  hojag.Axes(xlCategory).MajorGridlines.Select;
    if dtPaso = 1.0 / 24.0 then
    begin
      if tipoGraficoPrincipal = areaApilada then
      begin
        hojag.Axes(xlCategory).TickLabelSpacing := 24;
        hojag.Axes(xlCategory).TickMarkSpacing := 12;
      end
      else
      begin
        hojag.Axes(xlCategory).MajorUnit := 1;
        hojag.Axes(xlCategory).MinorUnit := 1 / 4;
      end;
    end
    else if dtPaso = 1 then
    begin
      hojag.Axes(xlCategory).HasMinorGridlines := False;
      if tipoGraficoPrincipal = areaApilada then
      begin
        hojag.Axes(xlCategory).TickLabelSpacing := 7;
        hojag.Axes(xlCategory).TickMarkSpacing := 1;
        hojag.Axes(xlCategory).MajorUnit := 3;
        hojag.Axes(xlCategory).MajorUnitScale := xlMonths;
        hojag.Axes(xlCategory).MinorUnit := 1;
        hojag.Axes(xlCategory).MinorUnitScale := xlMonths;
      end
      else
      begin
        hojag.Axes(xlCategory).MajorUnit := 7;
        hojag.Axes(xlCategory).MinorUnit := 1;
      end;
    end
    else if dtPaso >= 7 then
    begin
      if tipoGraficoPrincipal = areaApilada then
      begin
        hojag.Axes(xlCategory).TickLabelSpacing := 4;
        hojag.Axes(xlCategory).TickMarkSpacing := 1;
      end
      else
      begin
        hojag.Axes(xlCategory).MajorUnit := 365.2425 / 1.0;
        hojag.Axes(xlCategory).MinorUnit := 365.2425 / 3.0;
      end;
    end;




    plot_area := hojag.PlotArea;
    hojag.ChartArea.Border.LineStyle := xlDash;
    Plot_Area.Border.LineStyle := xlDot;

    plot_area.Select;
    (*
    system.writeln( 'Chart Area TH: (', hojag.chartarea.top, ', ',  hojag.chartarea.height,')' );
    system.writeln( 'Plot Area TH: (', plot_area.top,', ' , plot_area.height,')');
    system.writeln( 'Eje_x TH: ', eje_x.top, ', ', eje_x.height,')' );
    *)
    //    plot_area.height:= hojag.chartarea.height - 88 - plot_area.top; // - eje_x.height;

  end;
  {$ENDIF}

  //  aplicarPropiedadesASeries(xls, nombreHojaGrafico, tipoGraficoPrincipal, tiposGraficos, ejes, colores);
end;

(*

procedure aplicarPropiedadesASeries(xls: TExcelFile; nombreHoja: String;
                                    tipoGraficoPrincipal: TTipoGrafico; tiposGraficos: TDAOfTTipoGrafico;
                                    ejes: TDAOfTTipoEje;
                                    colores: TDAOfTColor);
var
  hojag, serie: Variant;
  i: Integer;
  colorIndexI: Integer;
  versionOffice: NReal;
  aux: TPaletaColoresExcel;
begin
  hojag:= xls.Hoja(nombreHoja);

  versionOffice:= xls.version;
  if versionOffice < versionOffice2007 then
    aux:= xls.getPaletaColores;

  for i:= 0 to High(tiposGraficos) do
  begin
    serie:= hojag.SeriesCollection(i + 1);
    if tiposGraficos[i] <> tipoGraficoPrincipal then
      serie.ChartType:= TTipoGraficoToXLConst(tiposGraficos[i]);
    serie.AxisGroup:= TTipoEjeToXLConst(ejes[i]);

    if colores[i] <> colorAutomatico then
    begin
      if versionOffice < versionOffice2007 then
      begin
        colorIndexI:= getColorIndex(colores[i], aux);

        if tiposGraficos[i] in tiposGraficosConColorInterior then
          serie.Interior.Colorindex:= colorIndexI;
        serie.Border.Colorindex:= colorIndexI;
        if tiposGraficos[i] in tiposGraficosConMarcadores then
        begin
          serie.MarkerStyle:= xlAutomatic;
          serie.MarkerBackgroundColorIndex:= colorIndexI;
          serie.MarkerForegroundColorIndex:= colorIndexI;
        end;
      end
      else
      begin
        if tiposGraficos[i] in tiposGraficosConColorInterior then
          serie.Interior.Color:= colores[i];
        serie.Border.Color:= colores[i];
        if tiposGraficos[i] in tiposGraficosConMarcadores then
        begin
          serie.MarkerStyle:= xlAutomatic;
          serie.MarkerBackgroundColor:= colores[i];
          serie.MarkerForegroundColor:= colores[i];
        end;
      end;
    end;
  end;
end;
*)



procedure WriteMatToXLS(xls: TExcelFile; nombreHoja: string;
  mat: TMatOfNReal; titulo, unidades: string; nPasos: integer;
  nCronicas: integer; dtFechaPrimerPaso: TDateTime; dtPaso: double;
  decimales: integer; Print_Todas: boolean; Print_promedio: boolean;
  Pre_Ordenar: boolean; TipoImpresion_PE: boolean; Print_probAisladas: TDAofNReal;
  chart_Mat: boolean; minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal);
var
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  iProbAisladas: array of integer;
  aprom: NReal;
  kProb: integer;
  hayAdicionales: boolean;
  aval: NReal;
  colIni, colFin, filaIni, filaFin: integer;
  pe_ant: NReal;

begin

  setlength(iProbAisladas, length(Print_probAisladas));
  for kProb := 0 to high(Print_probAisladas) do
  begin
    iCronica := round(NCronicas * Print_probAisladas[kProb]) - 1;

    // previendo que alguien escriba porbabilidades <0 o > 1 o que
    // por algn redondeo nos vayamos de rango.
    if iCronica < 0 then
      iCronica := 0
    else if iCronica > (NCronicas - 1) then
      iCronica := (NCronicas - 1);

    iProbAisladas[kProb] := iCronica;
  end;

  hayAdicionales := Print_promedio or (length(Print_probAisladas) > 0);

  nombreHoja := PurificarNombreHoja(nombreHoja);
  xls.agregoHoja(nombreHoja);
  xls.go(nombreHoja, 1, 1);

  xls.writeln(titulo + ' ' + unidades);

  //Para evitar el warning
  colIni := -1;
  colFin := -1;

  filaIni := xls.fila; // fila del encabezado
  filaFin := filaIni + nPasos; // ultima fila de datos


  xls.Write('paso');

  if Print_Todas then
  begin
    colIni := xls.columna;
    colFin := colIni + nCronicas;
    xls.Write('');
    for iCronica := 0 to NCronicas - 1 do
      xls.Write((iCronica + 1) / NCronicas);
  end;

  if hayAdicionales then
  begin
    xls.Write('');

    colIni := xls.columna;
    colFin := colIni + Length(Print_ProbAisladas);
    if Print_promedio then
      Inc(colFin);
    filaIni := xls.fila;
    filaFin := filaIni + nPasos;

    xls.Write('');
    if Print_Promedio then
      xls.Write('Prom');

    if TipoImpresion_PE then
    begin
      for kProb := 0 to high(iProbAisladas) do
        xls.Write('Pe' + FloatToStrF(Print_ProbAisladas[kProb] *
          100, ffFixed, 6, 1) + '%');
    end
    else
    begin
      Inc(colFin);
      pe_ant := 0;
      for kProb := 0 to high(iProbAisladas) do
      begin
        xls.Write('VaR(' + FloatToStrF(pe_ant * 100, ffFixed, 6, 1) +
          '-' + FloatToStrF(Print_ProbAisladas[kProb] * 100, ffFixed, 6, 1) + ')%');
        pe_ant := Print_ProbAisladas[kProb];
      end;
      xls.Write('VaR(' + FloatToStrF(pe_ant * 100, ffFixed, 6, 1) +
        '-' + FloatToStrF(100, ffFixed, 6, 1) + ')%');
    end;
  end;
  xls.writeln;

  for iPaso := 0 to NPasos - 1 do
  begin
    if Pre_Ordenar then
      QuickSort_Decreciente(mat[iPaso]);


    fechaDelPaso := dtFechaPrimerPaso + dtPaso * iPaso;
    xls.Write(IntToStr(iPaso + 1));

    if Print_Todas then
      //      xls.Write(DateTimeToIsoStr(fechaDelPaso));
      xls.Write(fechaDelPaso);

    aProm := 0;
    if Print_Todas or Print_promedio then
    begin
      for iCronica := 0 to NCronicas - 1 do
      begin
        aval := mat[iPaso][iCronica];
        if Print_Todas then
          xls.Write(aval);
        aProm := aProm + aval;
      end;
      aProm := aProm / NCronicas;
    end;

    if hayAdicionales then
    begin
      xls.Write('');
      //      xls.Write(DateTimeToIsoStr(fechaDelPaso));
      xls.Write(fechaDelPaso);

      if Print_Promedio then
        xls.Write(aProm);

      if TipoImpresion_PE then
      begin
        for kProb := 0 to high(iProbAisladas) do
          xls.Write(mat[iPaso][iProbAisladas[kProb]]);
      end
      else
      begin
        aval := promediarProbs(mat[iPaso], 0, iProbAisladas[0]);
        xls.Write(aval);
        for kProb := 1 to high(iProbAisladas) do
        begin
          aval := promediarProbs(mat[iPaso], iProbAisladas[kProb - 1],
            iProbAisladas[kProb]);
          xls.Write(aval);
        end;
        aval := promediarProbs(mat[iPaso], iProbAisladas[high(iProbAisladas)],
          NCronicas - 1);
        xls.Write(aval);
      end;
    end;
    xls.writeln;
  end;
  xls.writeln;


  {$IFNDEF SIM_EXCEL}
  // formatedo del rea de datos
  xls.SelRango(filaIni + 1, colIni + 1, filaFin, colFin);
  if xls.version = 14 then
    xls.CambiarFormato(xf_formatoStr(decimales))
  else
    xls.CambiarFormato('General');
  {$ENDIF}

  // formatedo de las fechas
  xls.SelRango(filaIni + 1, colIni, filaFin, colIni);

  if (dtPaso < 1) then
    xls.CambiarFormato(SysUtils.ShortDateFormat + ' hh')
  else
    xls.CambiarFormato(SysUtils.ShortDateFormat);


  if chart_Mat then
  begin
    chartMat_SimpleEje_ColoresAuto(xls,
      nombreHoja, titulo, unidades,
      colIni, colFin, filaIni, filaFin,
      minEjeYAuto, maxEjeYAuto,
      minEjeY, MaxEjeY,
      dtFechaPrimerPaso, dtFechaPrimerPaso + (nPasos - 1) * dtPaso,
      dispersion, dtPaso);

  end;
end;


procedure writeHistogramaGlobalToXls(xls: TExcelFile; nombreHoja: string;
  mat: TMatOfNReal; titulo, unidades: string; decimales: integer;
  minX, maxX: NReal; nPuntos: integer{;
                                     chart_Mat: boolean;
                                     minEjeYAuto, maxEjeYAuto: boolean;
                                     minEjeY, MaxEjeY: NReal});
var
  i, j, idxVal: integer;
  //  min, max: NReal;
  histo, histoAcum: TDAofNReal;
  x, invNPuntosCronicas, deltaMaxMin, invDeltaMaxMin, deltaX: NReal;

  //  filaContenido: TDAOfVariant;

  filaIni, filaFin, colIni, colFin: integer;
begin
  nombreHoja := PurificarNombreHoja(nombreHoja);

  deltaMaxMin := maxX - minX;
  invDeltaMaxMin := 1 / deltaMaxMin;
  deltaX := deltaMaxMin / (nPuntos - 1);
  invNPuntosCronicas := 1 / (length(mat) * length(mat[0]));
  SetLength(histo, nPuntos);

  for i := 0 to high(histo) do
    histo[i] := 0;


  for i := 0 to high(mat) do
  begin
    for j := 0 to high(mat[i]) do
    begin
      idxVal := trunc(((mat[i][j] - minX) * invDeltaMaxMin) * high(histo));
      if idxVal < 0 then
        idxVal := 0
      else if idxVal > high(histo) then
        idxVal := high(histo);
      histo[idxVal] := histo[idxVal] + invNPuntosCronicas;
    end;
  end;

  SetLength(histoAcum, length(histo));
  histoAcum[0] := histo[0];
  for i := 1 to high(histoAcum) do
    histoAcum[i] := histoAcum[i - 1] + histo[i];

  xls.agregoHoja(nombreHoja);
  xls.go(nombreHoja, 1, 1);

  xls.writeln(titulo + ' ' + unidades);

  filaIni := xls.fila;   // fila del encabezado
  colIni := xls.columna; // columna de datos
  filaFin := filaIni + length(histoAcum); // ltima fila de datos.
  colFin := colIni + 1; // seguna columna con las probabilidades

  xls.Write(titulo);
  xls.Write(RS_PROBABILIDAD_ACUMULADA);
  xls.writeln;
  x := minX;

  for i := 0 to high(histoAcum) do
  begin
    xls.Write(x);
    xls.Write(histoAcum[i]);
    xls.writeln;
    x := x + deltaX;
  end;


  // formatedo columna de valores de X
  xls.SelRango(filaIni + 1, colIni, filaFin, colIni);
  {$IFNDEF SIM_EXCEL}
  if xls.version = 14 then
    xls.CambiarFormato(xf_formatoStr(decimales))
  else
    xls.CambiarFormato('General');
  {$ENDIF}
  // formatedo las probabilidades acumuladas;
  xls.SelRango(filaIni + 1, colFin, filaFin, colFin);
  xls.CambiarFormato('0%');

  {
  if chart_Mat then
  begin
    chartMat(xls, nombreHoja, titulo, unidades, colIni, colFin, filaIni, filaFin,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY, 1/ Length(histo), 1, dispersion);
  end;
 }
end;

procedure WriteMatToXLS_SinOrdenar(xls: TExcelFile; nombreHoja: string;
  mat: TMatOfNReal; titulo, unidades: string; titulosCols: TDAofString;
  nPasos: integer; nCronicas: integer; dtFechaPrimerPaso: TDateTime;
  dtPaso: double; decimales: integer; Print_promedio: boolean;
  chart_Mat: boolean; minEjeYAuto, maxEjeYAuto: boolean; minEjeY, MaxEjeY: NReal);
var
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  aprom: NReal;
  aval: NReal;
  colIni, colFin, filaIni, filaFin: integer;

  nHojas, kHoja: integer;
  iCronIni, iCronM, iCronFin: integer;
  sNombreHoja: string;
begin
  nombreHoja := PurificarNombreHoja(nombreHoja);
  //Para sacar el warning
  colIni := -1;
  filaIni := -1;
  ColFin := -1;
  filaFin := -1;

  nHojas := ((nCronicas - 1) div 250) + 1;

  for kHoja := 1 to nHojas do
  begin
    if (nHojas > 1) then
      sNombreHoja := nombreHoja + '_' + IntToStr(kHoja)
    else
      sNombreHoja := nombreHoja;

    xls.agregoHoja(sNombreHoja);

    iCronIni := (kHoja - 1) * 250;
    iCronFin := min((nCronicas - 1), iCronIni + 250 - 1);
    iCronM := max(iCronIni - 1, min(high(titulosCols), iCronFin));

    xls.go(sNombreHoja, 1, 1);

    xls.writeln(titulo + ' ' + unidades);

    filaIni := xls.fila;  // fila encabezado
    filaFin := filaIni + nPasos; // ultima fila de datos

    xls.Write('paso');

    colIni := xls.columna; // columna de fechas
    colFin := colIni + iCronFin - iCronIni + 1; // ultima columna de datos

    xls.Write('');


    for iCronica := iCronIni to iCronM do
      xls.Write(titulosCols[iCronica]);
    //Si faltaron titulos de columnas como parametro imprime Columna y su nmero
    for iCronica := iCronM + 1 to iCronFin do
      xls.Write('Col_' + IntToStr(iCronica + 1));

    if Print_promedio then
    begin
      Inc(colFin);
      xls.Write('Prom');
    end;

    xls.writeln;
    for iPaso := 0 to NPasos - 1 do
    begin
      fechaDelPaso := dtFechaPrimerPaso + dtPaso * iPaso;
      xls.Write(IntToStr(iPaso + 1));
      //      xls.Write(DateTimeToIsoStr(fechaDelPaso));
      xls.Write(fechaDelPaso);

      aProm := 0;
      for iCronica := iCronIni to iCronFin do
      begin
        aval := mat[iPaso][iCronica];
        xls.Write(aval);
        aProm := aProm + aval;
      end;
      aProm := aProm / NCronicas;

      if Print_Promedio then
        xls.Write(aProm);
      xls.writeln;
    end;
    xls.writeln;

    // formatedo del rea de datos
    xls.SelRango(filaIni + 1, colIni + 1, filaFin, colFin);

      {$IFNDEF SIM_EXCEL}
    if xls.version = 14 then
      xls.CambiarFormato(xf_formatoStr(decimales))
    else
      xls.CambiarFormato('General');
{$ENDIF}
    // formatedo de las fechas
    xls.SelRango(filaIni + 1, colIni, filaFin, colIni);
    if (dtPaso < 1) then
      xls.CambiarFormato(SysUtils.ShortDateFormat + ' hh')
    else
      xls.CambiarFormato(SysUtils.ShortDateFormat);

  end;
  xls.writeln;

  if (nHojas = 1) and chart_Mat then
  begin

    chartMat_SimpleEje_ColoresAuto(xls,
      nombreHoja, titulo, unidades,
      colIni, colFin, filaIni, filaFin,
      minEjeYAuto, maxEjeYAuto,
      minEjeY, MaxEjeY,
      dtFechaPrimerPaso, dtFechaPrimerPaso + (nPasos - 1) * dtPaso, dispersion, dtPaso);
  end;
end;


{$ENDIF}

procedure calcPromedios(const mats: array of TMatOfNReal; iPaso: integer;
  var resultado: TDAofNReal);
var
  i: integer;
begin
  for i := 0 to high(mats) do
    if iPaso < length(mats[i]) then
      resultado[i] := vprom(mats[i][iPaso])
    else
      resultado[i] := vprom(mats[i][high(mats[i])]);
end;

procedure calcDesviacionesEstandar(const mats: array of TMatOfNReal;
  iPaso: integer; var resultado: TDAofNReal);
var
  i, j: integer;
  filaPaso, proms: TDAofNReal;
begin
  SetLength(proms, length(mats));
  calcPromedios(mats, iPaso, proms);

  for i := 0 to high(mats) do
  begin
    if iPaso < length(mats[i]) then
      filaPaso := mats[i][iPaso]
    else
      filaPaso := mats[i][high(mats[i])];

    resultado[i] := 0;
    if length(filaPaso) > 1 then
    begin
      for j := 0 to High(filaPaso) do
        resultado[i] := resultado[i] + Sqr(filaPaso[j] - proms[i]);
      resultado[i] := resultado[i] / (Length(filaPaso) - 1);
    end;
  end;
  SetLength(proms, 0);
end;

procedure calcProbsExcedencia(const mats: array of TMatOfNReal;
  preOrdenar: boolean; iPaso: integer; probExcedencia: NReal;
  var resultado: TDAofNReal);
var
  i, iProbExcedencia: integer;
  filaPaso: TDAofNReal;
  kPaso: integer;
begin
  for i := 0 to high(mats) do
  begin
    if iPaso < length(mats[i]) then
      kPaso := iPaso
    else
      kPaso := high(mats[i]);

    filaPaso := copy(mats[i][kPaso], 0, length(mats[i][kPaso]));

    if preOrdenar then
      QuickSort_Decreciente(filaPaso);
    iProbExcedencia := round(length(filaPaso) * probExcedencia) - 1;
    iProbExcedencia := max(0, min(high(filaPaso), iProbExcedencia));
    resultado[i] := filaPaso[iProbExcedencia];
  end;
end;


procedure calcValoresEnRiesgo(const mats: array of TMatOfNReal;
  preOrdenar: boolean; iPaso: integer; probExcedencia1, probExcedencia2: NReal;
  var resultado: TDAofNReal);
var
  i, j, iProbExcedencia1, iProbExcedencia2: integer;
  filaPaso: TDAofNReal;
  aval: NReal;
  kPaso: integer;

begin
  for i := 0 to high(mats) do
  begin

    if iPaso < length(mats[i]) then
      kPaso := iPaso
    else
      kPaso := high(mats[i]);

    filaPaso := copy(mats[i][kPaso], 0, length(mats[i][kPaso]));
    if preOrdenar then
      QuickSort_Decreciente(filaPaso);
    iProbExcedencia1 := trunc(high(filaPaso) * probExcedencia1);
    iProbExcedencia2 := trunc(high(filaPaso) * probExcedencia2);
    aval := 0;
    for j := iProbExcedencia1 to iProbExcedencia2 do
      aval := aval + filaPaso[j];
    resultado[i] := aval / (iProbExcedencia2 - iProbExcedencia1 + 1);
  end;
end;


{$IFNDEF SIMRES3SOLOTEXTO}

procedure WriteValoresToXLS(xls: TExcelFile; tipoValores: TTipoValoresAComparar;
  probExcedencia: NReal; Pre_Ordenar: boolean; ProbExcedencia_Sup: NReal;
  nombresVars: TDAofString; mats: array of TMatOfNReal; nombreHoja: string;
  titulo, unidades: string; dtFechaPrimerPaso: TDateTime; dtPaso: double;
  decimales: integer; graficar: boolean; tiposGraficos: TDAOfTTipoGrafico;
  ejes: TDAOfTTipoEje; colores: TDAOfTColor; minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);
var
  iPaso, iMats: integer;
  valores: TDAofNReal;
  descTipoValor: string;
  colIni, colFin, filaIni, filaFin: integer;

begin
  nombreHoja := PurificarNombreHoja(nombreHoja);
  xls.agregoHoja(nombreHoja);
  xls.go(nombreHoja, 1, 1);

  xls.writeln(titulo + ' ' + unidades);

  xls.Write('paso');

  filaIni := xls.fila;
  filaFin := filaIni + Length(mats[0]);
  colIni := xls.columna;
  colFin := colIni + length(mats);

  xls.Write('');
  descTipoValor := TTipoValoresACompararToShortStringSingular_(tipoValores,
    probExcedencia);
  //for iMats:= 0 to high(mats) do
  //Escribo las matrices al reves porque excel las grafica de atras para adelante
  //  for iMats:= high(mats) downto 0 do
  for iMats := 0 to high(mats) do
    xls.Write(nombresVars[iMats] + '_' + descTipoValor);
  xls.writeln;

  SetLength(valores, length(mats));
  for iPaso := 0 to high(mats[0]) do
  begin
    case tipoValores of
      Promedios: calcPromedios(mats, iPaso, valores);
      DesviacionesEstandar: calcDesviacionesEstandar(mats, iPaso, valores);

      ProbabilidadesDeExcedencia: calcProbsExcedencia(mats, pre_Ordenar, iPaso,
          probExcedencia, valores);

      ValoresEnRiesgo: calcValoresEnRiesgo(mats, pre_Ordenar, iPaso,
          probExcedencia, ProbExcedencia_Sup, valores);

    end;

    xls.Write(iPaso + 1);
    //    xls.Write(DateTimeToIsoStr(dtFechaPrimerPaso + iPaso * dtPaso));
    xls.Write(dtFechaPrimerPaso + iPaso * dtPaso);

    //Escribo las matrices al revs porque excel las grafica de atras para adelante
    //    for iMats:= high(valores) downto 0 do
    for iMats := 0 to high(valores) do
      xls.Write(valores[iMats]);
    xls.writeln;
  end;

  // formatedo del rea de datos
  xls.SelRango(filaIni + 1, colIni + 1, filaFin, colFin);
    {$IFNDEF SIM_EXCEL}
  if xls.version = 14 then
    xls.CambiarFormato(xf_formatoStr(decimales))
  else
    xls.CambiarFormato('General');
{$ENDIF}
  // formatedo de las fechas
  xls.SelRango(filaIni + 1, colIni, filaFin, colIni);
  if (dtPaso < 1) then
    xls.CambiarFormato(SysUtils.ShortDateFormat + ' hh')
  else
    xls.CambiarFormato(SysUtils.ShortDateFormat);

  if graficar then
  begin
    chartMat_MultiEje_Coloreable(xls,
      nombreHoja, titulo, unidades,
      colIni, colFin, filaIni, filaFin,
      minEjeYAuto, maxEjeYAuto,
      minEjeY, MaxEjeY,
      dtFechaPrimerPaso, dtFechaPrimerPaso + (high(mats[0]) * dtPaso),
      tiposGraficos, ejes, colores, dtPaso);
  end;

end;



function TTipoGraficoToXLConst(tipoGrafico: TTipoGrafico;
  tipoPrincipal: TTipoGrafico = dispersion): integer;
begin
  case tipoGrafico of
    //    linea           : result:= xlLineMarkers;
    dispersion:
      {$IFDEF SIM_EXCEL}
      Result := xlXYScatterLines;
      {$ELSE}
      if tipoPrincipal = dispersion then
        Result := xlXYScatterLines
      else
        Result := xlLineMarkers;
      {$ENDIF}
    areaApilada: Result := xlAreaStacked;
    else
      raise Exception.Create('uPrint.TTipoGraficoToXLConst: TTipoGrafico desconocido ' +
        IntToStr(Ord(tipoGrafico)));
  end;
end;

function TTipoGraficoToString(tipoGrafico: TTipoGrafico): string;
begin
  case tipoGrafico of
    //    linea       : result:= 'Lneas';
    areaApilada: Result := 'are';
    dispersion: Result := 'dis';
    else
      raise Exception.Create('uPrint.TTipoGraficoToString: tipo de grafico desconocido '
        + IntToStr(Ord(tipoGrafico)));
  end;
end;

function StringToTTipoGrafico(tipoGrafico: string): TTipoGrafico;
var
  flg_asignado: boolean;
begin
{  if CompareStr(tipoGrafico, 'Lneas') = 0 then
    result:= linea
  else }
  flg_asignado := False;


  if (pos('Area', tipoGrafico) > 0) or (tipoGrafico = 'are') then
    Result := areaApilada
  else if (pos('Disp', tipoGrafico) > 0) or (tipoGrafico = 'dis') then
    Result := dispersion
  else
    raise Exception.Create('uPrint.StringToTTipoGrafico: tipo de grfico desconocido ' +
      tipoGrafico);
end;

function TTipoEjeToXLConst(tipoEje: TTipoEje): integer;
begin
  case tipoEje of
    Primario: Result := 1;
    Secundario: Result := 2;
    else
      raise Exception.Create('uPrint.TTipoEjeToXLConst: tipo de eje desconocido ' +
        IntToStr(Ord(tipoEje)));
  end;
end;

function TTipoEjeToString(tipoEje: TTipoEje): string;
begin
  case tipoEje of
    Primario: Result := 'pri';
    Secundario: Result := 'sec';
    else
      raise Exception.Create('uPrint.TTipoEjeToXLConst: tipo de eje desconocido ' +
        IntToStr(Ord(tipoEje)));
  end;
end;

function StringToTTipoEje(tipoEje: string): TTipoEje;
begin
  if (tipoEje = 'Primario') or (tipoEje = 'pri') then
    Result := Primario
  else if (tipoEje = 'Secundario') or (tipoEje = 'sec') then
    Result := Secundario
  else
    raise Exception.Create('StringToTTipoEje: tipo de eje desconocido ' + tipoEje);
end;

function TTipoValoresACompararToString(tipoValoresAComparar:
  TTipoValoresAComparar): string;
begin
  case tipoValoresAComparar of
    Promedios: Result := 'prom';
    DesviacionesEstandar: Result := 'desv';
    ProbabilidadesDeExcedencia: Result := 'pbex';
    ValoresEnRiesgo: Result := 'var';
    else
      raise Exception.Create(
        'uPrintCronVars.TTipoValoresACompararToString: tipo de grafico desconocido ' +
        IntToStr(Ord(tipoValoresAComparar)));
  end;
end;

function StringToTTipoValoresAComparar(tipoValoresAComparar: string):
TTipoValoresAComparar;
begin
  if (tipoValoresAComparar = 'Promedios') or (tipoValoresAcomparar = 'prom') then
    Result := Promedios
  else if (tipoValoresAComparar = 'Desviaciones Estandar') or
    (tipoValoresAComparar = 'desv') then
    Result := DesviacionesEstandar
  else if (tipoValoresAComparar = 'Probabilidades de Excedencia') or
    (tipoValoresAComparar = 'pbex') then
    Result := ProbabilidadesDeExcedencia
  else if (tipoValoresAComparar = 'Valores en Riesgo') or
    (tipoValoresAComparar = 'var') then
    Result := ValoresEnRiesgo
  else
    raise Exception.Create(
      'uPrintCronVars.StringToTTipoValoresAComparar: tipo de grfico desconocido ' +
      tipoValoresAComparar);
end;

function TTipoValoresACompararToShortStringSingular_(tipoValoresAComparar:
  TTipoValoresAComparar; probExcedencia: NReal): string;
begin
  case tipoValoresAComparar of
    Promedios: Result := RS_XLS_PROMEDIO;
    DesviacionesEstandar: Result := RS_XLS_DESVIACION_ESTANDAR;
    ProbabilidadesDeExcedencia: Result :=
        RS_XLS_PROBABILIDAD_DE_EXCEDENCIA + ' ' +
        FloatToStrF(probExcedencia * 100, ffFixed, 6, 2) + '%';
    ValoresEnRiesgo: Result :=
        RS_XLS_VALOR_EN_RIESGO + ' ' + FloatToStrF(probExcedencia *
        100, ffFixed, 6, 2) + '%';

    else
      raise Exception.Create(
        'uPrintCronVars.TTipoValoresACompararToShortStringSingular: tipo de grafico desconocido '
        + IntToStr(Ord(tipoValoresAComparar)));
  end;
end;

{$ENDIF}
end.
